script_author('MLycoris')
script_version('0.7')
require 'lib.moonloader'
local faicons = require('fAwesome6')
local imgui = require 'mimgui'
local ffi = require 'ffi'
local encoding = require 'encoding'
local sampev = require 'lib.samp.events'
local inicfg = require 'inicfg'
local ini = inicfg.load({
    set =
    {
        posX = 500,
        posY = 500,
        stats = false, -- 
        skipdi = false, --   
        autoH = false, --  H
        autoAlt = false, --  
        allaz = 0, --  
        allmon = 0, --  
        barellcost = 40000, --   ( )
        minifpsup = false, --    
        zaronwin = false, --   
        azonwin = false, --   
        today = 0, -- 
        zartoday = 0, --   
        zaraztoday = 0, --   
        log = false, -- 
        moneydft = 133950, --      
        azbarcost = 12, --   
        cursvc = 202, --     
        autotake = false, --   
        autoput = false, --  
        cd = 60, --   
        currentVersion = -1, --  
        zarsecurity = 0, --   
        autoSellCompany = false, --  
    },
}, 'OilHelper.ini')
local status = inicfg.load(settings, 'OilHelper.ini')
if not doesFileExist('moonloader/config/OilHelper.ini') then inicfg.save(ini, 'OilHelper.ini') end
-- == JSON == --
function json(filePath)
    local filePath = getWorkingDirectory()..'\\config\\'..(filePath:find('(.+).json') and filePath or filePath..'.json')
    local class = {}
    if not doesDirectoryExist(getWorkingDirectory()..'\\config') then
        createDirectory(getWorkingDirectory()..'\\config')
    end
    function class:Save(tbl)
        if tbl then
            local F = io.open(filePath, 'w')
            F:write(encodeJson(tbl) or {})
            F:close()
            return true, 'ok'
        end
        return false, 'table = nil'
    end
    function class:Load(defaultTable)
        if not doesFileExist(filePath) then
            class:Save(defaultTable or {})
        end
        local F = io.open(filePath, 'r+')
        local TABLE = decodeJson(F:read() or {})
        F:close()
        for def_k, def_v in next, defaultTable do
            if TABLE[def_k] == nil then
                TABLE[def_k] = def_v
            end
        end
        return TABLE
    end
    return class
end
local OilHelperJSON = json('OilHelper.json'):Load({})
function save()
    inicfg.save(ini, 'OilHelper.ini')
    json('OilHelper.json'):Save(OilHelperJSON)
end

local zaraz, zarmon, oil, number, numberr, fill, plusmon = 0, 0, 0,0, 0, 0, 0
local objectcheck, movewin, oilmax, oilmin = false, false, false, false
local textCoords = {x = nil, y = nil, z = nil}
local parse = ''
local ingorelist = {}

encoding.default = 'CP1251'
local u8 = encoding.UTF8

local llimit, dlimit = 0, 0
local lstart, dstart = 0, 0
local ltimer, dtimer = 0, 0
local curTab = 1

local new, str = imgui.new, ffi.string      
local bool = {
    WinState = new.bool(),
    cd = new.int(ini.set.cd), --     
    autotake = new.bool(ini.set.autotake), --    ()
    autoput = new.bool(ini.set.autoput), --    ()
    azonwin = new.bool(ini.set.azonwin), --   
    show = new.bool(ini.set.stats), --  
    skipdi = new.bool(ini.set.skipdi), --   
    autoH = new.bool(ini.set.autoH), --  
    autoAlt = new.bool(ini.set.autoAlt), --  
    minifpsup = new.bool(ini.set.minifpsup), --   
    zaronwin = new.bool(ini.set.zaronwin), --   
    log = new.bool(ini.set.log), --   
    zaraztoday = new.int(ini.set.zaraztoday), --   
    autoSellCompany = new.bool(ini.set.autoSellCompany) --  
}
local winInfo = {
    firstUse = {[[{FFFFFF}  {FF634F}[{FFFFFF}07{FF634F}]{FFFFFF} MLycoris{FF634F}.
{FFFFFF},   {FF634F}Oil{FFFFFF}Helper{FF634F}.{FFFFFF}        {FF634F}.{FFFFFF}
{FFFFFF}   {a2653e} {FFFFFF} {42AAFF} {FFFFFF}{FF634F}.
 
{FFFFFF} {FF634F}:{FFFFFF}
{FFFFFF}/oilh -  {FF634F}:{FFFFFF}
-   -    ,      
-   -         / 
-   -       ,     
 
/oil max -    ,    
/oil min -    ,    500. 
/oil ignore <num> -    .         /oil max]]},
    update = {[[{FFFFFF} 0.7{FF634F}:{FFFFFF}
{FF634F}-{FFFFFF}   {FF634F};{FFFFFF} 
{FF634F}-{FFFFFF}  {FF634F};{FFFFFF}
{FF634F}-{FFFFFF}     {FF634F};{FFFFFF}
{FF634F}-{FFFFFF}      {FF634F};{FFFFFF}]]}
}

local sizeX, sizeY = getScreenResolution()

local newLarec = {
    larecCost = new.int()
}

imgui.OnFrame(function() return (dlimit ~= 0 or llimit ~= 0) and bool.show[0] or (bool.zaronwin[0] or bool.azonwin[0]) and not isGamePaused() end, function()
    imgui.SetNextWindowPos(imgui.ImVec2(ini.set.posX, ini.set.posY), imgui.Cond.Always, imgui.ImVec2(1, 1))
    imgui.SetNextWindowSize(imgui.ImVec2(-1, -1), imgui.Cond.Always)
    imgui.PushStyleColor(imgui.Col.WindowBg, imgui.ImVec4(0, 0, 0, 0.7))
    imgui.Begin('Stats', bool.show, imgui.WindowFlags.NoMove + imgui.WindowFlags.NoDecoration + imgui.WindowFlags.AlwaysAutoResize)
    if dlimit ~= 0 and bool.show[0] then
        local convertTime = os.date("!*t", dtimer)
        imgui.TextColoredRGB(u8('{FF634F}[{ffffff}DFT{FF634F}] [{ffffff}'..dlimit..'{FF634F}] {ffffff}' .. tostring(convertTime.min) .. ":" .. tostring(convertTime.sec)))
    end
    if llimit ~= 0  and bool.show[0] then
        local convertTime = os.date("!*t", ltimer)
        imgui.TextColoredRGB(u8('{FF634F}[{ffffff}{FF634F}] [{ffffff}'..llimit..'{FF634F}] {ffffff}' .. tostring(convertTime.min) .. ":" .. tostring(convertTime.sec)))
    end
    if bool.show[0] and (llimit ~= 0 or dlimit ~= 0) and (bool.zaronwin[0] or bool.azonwin[0]) then imgui.Separator() end
    if bool.zaronwin[0] then
        allmoney = string.format("%.2f", ini.set.allmon/1000000)
        zarmoney = string.format("%.2f", zarmon/1000000)
        imgui.TextColoredRGB(string.format(u8'{FF634F}%s{FFFFFF} %s .',faicons("SACK_DOLLAR"),zarmoney))
    end
    if bool.zaronwin[0] and bool.azonwin[0] then imgui.Separator() end
    if bool.azonwin[0] then
        imgui.TextColoredRGB(string.format(u8'{FF634F}%s{FFFFFF} %s .',faicons("COIN_VERTICAL"),sumFormat(zaraz),sumFormat(ini.set.allaz)))

    end
    imgui.PopStyleColor(1)
    imgui.End()
end).HideCursor = true

function getAllLarci()
    local costs = 0
    for index, data in pairs(OilHelperJSON) do
        costs = data.larecCost*data.larecKolvo + costs
    end
    return costs
end
function larecObnul()
    for index, data in pairs(OilHelperJSON) do
        data.larecKolvo = 0
    end
    save()
end

imgui.OnFrame(function() return bool.WinState[0] end, function()
    imgui.SetNextWindowPos(imgui.ImVec2(sizeX / 2, sizeY / 2), imgui.Cond.FirstUseEver, imgui.ImVec2(0.5, 0.5))
    imgui.SetNextWindowSize(imgui.ImVec2(-1, curTab == 2 and 600 or 500), imgui.Cond.FirstUseEver) -- 640
    imgui.Begin('1231', bool.WinState,imgui.WindowFlags.NoDecoration)
    if tostring(ini.set.currentVersion) == -1 or tostring(ini.set.currentVersion) ~= thisScript().version then
        imgui.OpenPopup('Welcome to the club, buddy!')
        if imgui.BeginPopupModal('Welcome to the club, buddy!', _, imgui.WindowFlags.NoResize) then
            imgui.TextColoredRGB(u8(table.concat(ini.set.currentVersion == -1 and winInfo.firstUse or ini.set.currentVersion ~= thisScript().version and winInfo.update, "\n")))
            if imgui.Button(u8'', imgui.ImVec2(imgui.GetWindowWidth()-10, 24)) then
                ini.set.currentVersion = thisScript().version
                inicfg.save(ini, 'OilHelper.ini')
                imgui.CloseCurrentPopup()
            end
            imgui.End()
        end
    end
    if imgui.BeginChild('Main', imgui.ImVec2(280, 120), true, imgui.WindowFlags.AlwaysAutoResize) then
        imgui.CenterText(faicons("DROPLET_DEGREE")..' OilHelper version 0.7') imgui.SameLine()
        imgui.SetCursorPosX(imgui.GetWindowWidth()-20) if imgui.Button('##CloseButton', imgui.ImVec2(15, 15)) then bool.WinState[0]  = false end
        imgui.Separator()
        for k,v in pairs({faicons("BRIEFCASE_BLANK")..u8' ',faicons("GEARS")..u8' ',faicons("BOX_DOLLAR")..u8' '}) do
            if imgui.stBut(v,k == curTab,imgui.ImVec2(imgui.GetWindowWidth()-8,24)) then curTab = k end
        end
        imgui.EndChild()
    end
    imgui.SetWindowSizeVec2(imgui.ImVec2(-1,curTab == 2 and 600 or 500))
    if imgui.BeginChild('WindowShit', imgui.ImVec2(280,-1), true, imgui.WindowFlags.AlwaysAutoResize) then
        
        if curTab == 1 then
            imgui.CenterText(u8'  ') imgui.Separator()
            imgui.TextColoredRGB(u8(string.format('{ffffff} {FF634F}: {FFFFFF}%s{FF634F}$\n{ffffff}{FF634F}: {ffffff}%s{FF634F}$\n{ffffff}{FF634F}: {FFFFFF}%s{FF634F}$\n{ffffff}  {FF634F}: {ffffff}%s{FF634F}$',sumFormat(zarmon),sumFormat(getAllLarci()),sumFormat(ini.set.zarsecurity),sumFormat(ini.set.allmon+getAllLarci()+ini.set.zarsecurity))))
            imgui.Separator()
            imgui.CenterText(u8'  -') imgui.Separator()
            local zarAZ = string.format('{ffffff} {FF634F}:{ffffff} %s {ffffff}AZ-Coins\n{ffffff}  {FF634F}:{ffffff} %s AZ-Coins',sumFormat(zaraz),sumFormat(ini.set.allaz))
            imgui.TextColoredRGB(u8(zarAZ))
            imgui.Separator()
            imgui.CenterText(u8'   ') imgui.Separator()
            imgui.TextColoredRGB(u8('{FFFFFF}{FF634F}:{ffffff}'..sumFormat(ini.set.zartoday)..'{FF634F} $\n{ffffff}AZ-Coins{FF634F}:{ffffff}'..sumFormat(ini.set.zaraztoday)..' {FF634F}'))
            imgui.Separator()
            if imgui.Checkbox(u8'    ', bool.log) then
                ini.set.log = bool.log[0]
                inicfg.save(ini, 'OilHelper.ini')
            end
            if imgui.Button(u8' ', imgui.ImVec2(270, 24)) then
                imgui.OpenPopup(u8'')
            end
            if imgui.BeginPopupModal(u8'', _, imgui.WindowFlags.NoResize) then
                if imgui.Button(u8'', imgui.ImVec2(280, 24)) then
                    imgui.CloseCurrentPopup()
                end
                if imgui.Button(u8' ', imgui.ImVec2(280, 24)) then
                    file = io.open(getWorkingDirectory()..'\\config\\OilHelperLOG.txt', 'w')
                    file:write('')
                    file:close()
                end
                for line in io.lines(getWorkingDirectory()..'\\config\\OilHelperLOG.txt') do
                    imgui.Text(line)
                end
                imgui.End()
            end
            if imgui.Button(u8'  ', imgui.ImVec2(270, 24)) then
                imgui.OpenPopup(u8'')
            end
            if imgui.BeginPopupModal(u8'', _, imgui.WindowFlags.NoResize) then
                imgui.Text(u8' ,    ?')
                if imgui.Button(u8'', imgui.ImVec2(135, 24)) then obnul() imgui.CloseCurrentPopup() end imgui.SameLine()
                if imgui.Button(u8'', imgui.ImVec2(135, 24)) then imgui.CloseCurrentPopup() end
                imgui.End()
            end
            if imgui.Button(u8'  ', imgui.ImVec2(270, 24)) then thisScript():reload() end
        elseif curTab == 2 then
            imgui.Indent(20)
            imgui.CenterText(u8'  ') imgui.Separator()
            if imgui.SliderInt('##SomeShit123', bool.cd, 1, 60,u8'%d .') then
                ini.set.cd = bool.cd[0] save()
            end
            imgui.Separator() imgui.CenterText(u8' ') imgui.Separator()
            if imgui.Checkbox(u8'  ', bool.show) then
                ini.set.stats = bool.show[0]
                inicfg.save(ini, 'OilHelper.ini')
            end
            if imgui.Checkbox(u8' ', bool.zaronwin) then
                ini.set.zaronwin = bool.zaronwin[0]
                inicfg.save(ini, 'OilHelper.ini')
            end
            if imgui.Checkbox(u8' AZ-Coins', bool.azonwin) then
                ini.set.azonwin = bool.azonwin[0]
                inicfg.save(ini, 'OilHelper.ini')
            end
            if imgui.Button(u8'', imgui.ImVec2(225, 24)) then movewin = true end
            imgui.Separator() imgui.CenterText(u8'') imgui.Separator()
            if imgui.Checkbox(u8'', bool.skipdi) then
                ini.set.skipdi = bool.skipdi[0]
                inicfg.save(ini, 'OilHelper.ini')
            end
            if imgui.Checkbox(u8' ', bool.autoSellCompany) then
                ini.set.autoSellCompany = bool.autoSellCompany[0]
                inicfg.save(ini, 'OilHelper.ini')
            end
            if imgui.Checkbox(u8'  ', bool.autoput) then
                ini.set.autoput = bool.autoput[0]
                inicfg.save(ini, 'OilHelper.ini')
            end
            if imgui.Checkbox(u8'  ', bool.autotake) then
                ini.set.autotake = bool.autotake[0]
                inicfg.save(ini, 'OilHelper.ini')
            end
            imgui.Separator() imgui.CenterText(u8'') imgui.Separator()
            if imgui.Checkbox(u8' 3 ', bool.minifpsup) then
                ini.set.minifpsup = bool.minifpsup[0]
                inicfg.save(ini, 'OilHelper.ini')
            end
            if imgui.Checkbox(u8' H ( )', bool.autoH) then
                ini.set.autoH = bool.autoH[0]
                inicfg.save(ini, 'OilHelper.ini')
            end
            if imgui.Checkbox(u8' Alt ( )', bool.autoAlt) then
                ini.set.autoAlt = bool.autoAlt[0]
                inicfg.save(ini, 'OilHelper.ini')
            end
        elseif curTab == 3 then
            if imgui.Button(u8' - ',imgui.ImVec2(imgui.GetWindowWidth()-9, 24)) then larecObnul() end imgui.Separator()
            for index, data in pairs(OilHelperJSON) do
                if imgui.CollapsingHeader(u8(data.larecName)..u8' | -: '..data.larecKolvo..'##'..index) then
                    local larecCost = new.char[512](data.larecCost) imgui.PushItemWidth(75)
                    if imgui.InputInt('##'..index,newLarec.larecCost,0,100000000) then
                        if newLarec.larecCost[0] >= 0 then
                            data.larecCost = newLarec.larecCost[0]
                            save()
                            newLarec.larecCost[0] = 0
                        else newLarec.larecCost[0] = 0 end
                    end imgui.PopItemWidth()
                    imgui.SameLine()
                    imgui.TextColoredRGB(u8('{FFFFFF} {FF634F}:{ffffff} ' .. sumFormat(data.larecCost).."{FF634F}$"))
                    if imgui.Button(u8' -##'..index,imgui.ImVec2(138, 24)) then
                        data.larecKolvo = 0 save()
                    end imgui.SameLine()
                    if imgui.Button(u8'##'..index,imgui.ImVec2(138, 24)) then
                        table.remove(OilHelperJSON, index) save()
                    end
                end
                imgui.Separator()
            end
        end
    end
    imgui.End()
end)

function terrcheck()
    local pX, pY, pZ = getCharCoordinates(PLAYER_PED)
    local shitman = getDistanceBetweenCoords3d(pX, pY, pZ, textCoords.x, textCoords.y, textCoords.z)
    if (pX >= 315 and pY >= 1244 and pX <= 716 and pY <= 1613) or (textCoords.x and shitman < 40) then
        return true
    else return false
    end
end

function main()
    while not isSampAvailable() do wait(50) end
    sampRegisterChatCommand('oilh', function()
        bool.WinState[0] = not bool.WinState[0]
    end)
    sampRegisterChatCommand('oil',function(arg)
        if string.match(arg,'max') then
            oilmax = true sampSendChat('/oilgroundlist')
        elseif string.match(arg,'min') then
            oilmin = true sampSendChat('/oilgroundlist')
        elseif string.match(arg,'ignore') then
            local ignore, number = arg:match('(.+) (.+)')
            if tonumber(number) and ignore == 'ignore' then
                table.insert(ingorelist,{number})
                sampAddChatMessage('{FF634F}[{FFFFFF}OilHelper{FF634F}] {FFFFFF} {FF634F}'..sumFormat(number)..'{FFFFFF}   .', -1)
            end
        end
    end)
    -- sampSendChat('/c      88     $250.000')
    -- sampSendChat('/c      77     12 AZ-Coins')
    if not doesFileExist(getWorkingDirectory()..'\\config\\OilHelperLOG.txt') then
        file = io.open(getWorkingDirectory()..'\\config\\OilHelperLOG.txt', 'a')
        file:write("")
        file:close()
    end
    local d = os.date("*t")
    if d.day ~= ini.set.today then
        if bool.log[0] then
            file = io.open(getWorkingDirectory()..'\\config\\OilHelperLOG.txt', 'a')
            file:write(u8"["..d.day..'.'..d.month..'.'..d.year..u8'] \nAZ: '..sumFormat(ini.set.zaraztoday)..u8'\n: '..sumFormat(ini.set.zartoday)..'\n====\n')
            file:close()
        end
        ini.set.zartoday = 0
        ini.set.zaraztoday = 0
        ini.set.today = d.day
        inicfg.save(ini, 'OilHelper.ini')
    end
    while true do wait(0)
        if movewin then
            ini.set.posX, ini.set.posY = getCursorPos()
            if dlimit == 0 and llimit == 0 then
                dlimit,llimit = 123,123
                if dlimit == 123 then
                    lstart = os.time() +1*60*ini.set.cd
                    dstart = os.time() +1*60*ini.set.cd
                end
            end
            if isKeyJustPressed(1) then
                if dlimit == 123 then
                    dlimit,dtimer,llimit,ltimer = 0,0,0,0
                end
                inicfg.save(ini, 'OilHelper.ini')
                movewin = false
            end
        end
        if dlimit ~= 0 then
            dtimer = dstart-os.time()
            convertTime = os.date("!*t", dtimer)
            if dtimer == 0 then
                dlimit = 0
            end
        end
        if llimit ~= 0 then
            ltimer = lstart-os.time()
            convertTime = os.date("!*t", ltimer)
            if ltimer == 0 then
                llimit = 0
            end
        end
    end
end

function CheckLarec(larec)
    local addStatus = true
    for index, data in pairs(OilHelperJSON) do
        if data.larecName:find(larec) then
            data.larecKolvo = data.larecKolvo + 1
            save()
            addStatus = false
        end
    end
    if addStatus then
        table.insert(OilHelperJSON, {
            larecName = tostring(larec),
            larecCost = 0,
            larecKolvo = 1,
        }) save()
        sampAddChatMessage('{FF634F}[{FFFFFF}OilHelper{FF634F}] {FFFFFF} {FF634F}:{ffffff} '..larec..'{FF634F}.{ffffff}     /oilh', -1)
    end
end

function sampev.onServerMessage(color, text)
    local text = text:gsub('{......}','')
    --  
    local newLarec = text:match(' : (.+)')
    if newLarec then CheckLarec(newLarec:gsub('%-',' ')) end
    --  
    local WBarrel_sell = text:match('     .+     %$(.+)')
    local GBarrel_sell_dollars = text:match('         %$(.+)')
    --    VC
    local VCWBarrel_sell = text:match('     .+     VC%$(.+)')
    --  
    local GBarrel_sell = text:match('     .+     (%d+) AZ%-Coins')
    if WBarrel_sell or GBarrel_sell_dollars then
        local newMoney = GBarrel_sell_dollars and GBarrel_sell_dollars:gsub('%p','') or WBarrel_sell and WBarrel_sell:gsub('%p','')
        if WBarrel_sell then
            llimit = llimit + 1
            if llimit == 1 then lstart = os.time() +1*60*ini.set.cd end
        else
            dlimit = dlimit + 1
            if dlimit == 1 then dstart = os.time() +1*60*ini.set.cd end    
        end
        zarmon = zarmon + newMoney
        ini.set.allmon = ini.set.allmon + newMoney
        ini.set.zartoday = ini.set.zartoday+newMoney -- 
        inicfg.save(ini, 'OilHelper.ini')
    elseif VCWBarrel_sell then
        plusmon = VCWBarrel_sell:gsub('%p','')*ini.set.cursvc
        zarmon = zarmon + plusmon
        ini.set.allmon = ini.set.allmon + plusmon
        ini.set.zartoday = ini.set.zartoday+plusmon -- 
        inicfg.save(ini, 'OilHelper.ini')
    elseif GBarrel_sell then
        dlimit = dlimit + 1
	    if dlimit == 1 then dstart = os.time() +1*60*ini.set.cd end
        zaraz = zaraz + GBarrel_sell
        ini.set.allaz = ini.set.allaz + GBarrel_sell
        zarmon = zarmon + ini.set.moneydft
        ini.set.allmon = ini.set.allmon + ini.set.moneydft
        ini.set.zartoday = ini.set.zartoday + ini.set.moneydft -- 
        ini.set.zaraztoday = ini.set.zaraztoday + GBarrel_sell -- 
        inicfg.save(ini, 'OilHelper.ini')
    --  
    elseif text:find('   .    !') then
        zarmon = zarmon - ini.set.barellcost
        ini.set.allmon = ini.set.allmon - ini.set.barellcost
        ini.set.zartoday = ini.set.zartoday-ini.set.barellcost -- 
        inicfg.save(ini, 'OilHelper.ini')
    --  
    elseif text:find('   .    !') then
        zaraz = zaraz - ini.set.azbarcost
        ini.set.allaz = ini.set.allaz - ini.set.azbarcost
        ini.set.zaraztoday = ini.set.zaraztoday - ini.set.azbarcost -- 
        inicfg.save(ini, 'OilHelper.ini')
    end
    --  
    local wBar, proc = text:match(' (.+)    (%d+).+,       ')
    if wBar and proc then
        lua_thread.create(function() wait(1000)
            if wBar:find('') then
                ini.set.zarsecurity = ini.set.zarsecurity+ini.set.moneydft*proc/100
                ini.set.zartoday = ini.set.zartoday + ini.set.moneydft*proc/100
                zarmon = zarmon+ini.set.moneydft*proc/100
            elseif wBar:find('') then
                ini.set.zartoday = ini.set.zartoday + plusmon*proc/100
                ini.set.zarsecurity = ini.set.zarsecurity+plusmon*proc/100
                zarmon = zarmon + plusmon*proc/100
            end inicfg.save(ini, 'OilHelper.ini')
        end) return {color,text} 
    end
end
--      (%d+)%%%,       .
--      (%d+)%%%,       .

function sampev.onSetPlayerAttachedObject(plID,index,create,obj)
    if obj.bone == 6 and obj.modelId == 3632 and select(2, sampGetPlayerIdByCharHandle(1)) == plID then
        objectcheck = true
    else objectcheck = false
    end
end
function sampev.onShowDialog(id, style, title, button1, button2, text)
    if bool.autoSellCompany[0] and title:find(' ') then
        local lineCount = 0
        for line in text:gmatch('([^\n\r]+)') do
            local canSell = line:match('  ')
            if canSell then
                sampSendDialogResponse(id, 1, lineCount, '')
                return false
            end
            lineCount = lineCount + 1
        end
    end
    if title:find('  ') then
        for line in text:gmatch('([^\n\r]+)') do
            local VCcost = line:gsub('{......}', ''):match('  VC%$  %: $(%d+)')
            if VCcost then
                if tostring(VCcost) ~= tostring(ini.set.cursvc) then
                    sampAddChatMessage('{FF634F}[{FFFFFF}OilHelper{FF634F}] {FFFFFF}  VC.  {FF634F}:{FFFFFF} '..VCcost..'{FF634F} VC$', -1)
                    ini.set.cursvc = VCcost
                    inicfg.save(ini, 'OilHelper.ini')
                end
            end
        end
    end
    if (bool.autotake[0] or bool.autoput[0]) and title:find('  ') then
        for line in text:gmatch('([^\n\r]+)') do
            line = line:gsub('{......}', ' ')
            local num, status = line:match('%(%d+) (.+)')
            if status:find('') and bool.autoput[0] and objectcheck then
                sampSendDialogResponse(id,1,num-1,'')
                return false
            end
            if status:find('') and bool.autotake[0] and not objectcheck then
                sampSendDialogResponse(id,1,num-1,'')
                return false
            end
        end
    end
    if bool.skipdi[0] == true and title:find(" ") then
        sampSendDialogResponse(id, 1, nil, nil)
        return false
    end
    if oilmax or oilmin then
        if title:find(' %: (%d+) %| %:') then
            parse = 0
            for str in text:gmatch('([^\n\r]+)') do
                str = str:gsub('{......}', ' ')
                number = str:match('(%d+)%.   %: %d+	 %d+ %/ %d+ ')
                if #ingorelist > 0 then
                    for k, v in ipairs(ingorelist) do
                        if tonumber(number) == tonumber(v[1]) then
                            str = ''
                        end
                    end
                end
                fill = 0
                parse = parse..'\n'..str
            end
            for strr in parse:gmatch('([^\n\r]+)') do
                strr = strr:gsub('{......}', ' ')
                -- %d+%.   %: %d+	 %d+ %/ %d+ 
                if strr:find('%d+%.   %: %d+	 %d+ %/ %d+ ') then
                    oil = tonumber(strr:match('%d+%.   %: %d+	 (%d+) %/ %d+ '))
                    if oilmax then
                        if oil >= fill then
                            fill = oil
                            numberr = strr:match('(%d+)%.   %: %d+	 %d+ %/ %d+ ')
                        end
                    elseif oilmin then
                        if 500 >= fill then
                            fill = oil
                            numberr = strr:match('(%d+)%.   %: %d+	 %d+ %/ %d+ ')
                        end
                    end
                end
            end
            lua_thread.create(function () wait(400) sampSendDialogResponse(id, 1, numberr, -1) end)
            local total_barrels = math.floor(fill/500)..' '..(math.floor(fill/500)<5 and '' or '')..').'
            sampAddChatMessage('{FF634F}[{FFFFFF}OilHelper{FF634F}] {FFFFFF}  {FF634F}{FFFFFF}'..numberr..'  '..sumFormat(fill)..' {FF634F}.{FFFFFF}  ( '..total_barrels, -1)
            oilmax = false
            oilmin = false
        end
        return false
    end
end
-- ==  ,    == --
function sampev.onDisplayGameText(style, time, text)
    if text:find('Barrel Rigs: (%d+)') and dtimer == 0 then --
        ligma = text:match('Barrel Rigs: (%d+)')
        dlimit = dlimit + 1
        if dlimit == 1 then
            dstart = os.time() + 1*60*math.ceil(ligma/60)
        end
    end
    if text:find('Barrel: (%d+)') and ltimer == 0 then -- 
        ligma = text:match('Barrel: (%d+)')
        llimit = llimit + 1
        if llimit == 1 then
            lstart = os.time() + 1*60*math.ceil(ligma/60)
        end
    end 
    if bool.autoAlt[0] == true then
        if text:match('~b~PRESS: ~w~ALT') or text:match('~r~Press~w~ ALT') then
            if isKeyDown(0x02) then -- 
                goKeyPressed(18) -- 
            end
        end
    end
    if bool.autoH[0] == true then
        if text:match('~b~PRESS: ~w~H') then
            if terrcheck() then
                if not isKeyDown(0x20) then -- 
                    setVirtualKeyDown(87,false)
                    goKeyPressed(72) -- H 
                end
            end
        end
    end 
end
-- ==  ,    == --
function sampev.onShowTextDraw(id, data)
    if data.text:find('Barrel Rigs: (%d+)') and dtimer == 0 then --
        ligma = data.text:match('Barrel Rigs: (%d+)')
        dlimit = dlimit + 1
        if dlimit == 1 then
            dstart = os.time() + 1*60*math.ceil(ligma/60)
        end
    end
    if data.text:find('Barrel: (%d+)') and ltimer == 0 then -- 
        ligma = data.text:match('Barrel: (%d+)')
        llimit = llimit + 1
        if llimit == 1 then
            lstart = os.time() + 1*60*math.ceil(ligma/60)
        end
    end 
    if bool.autoAlt[0] == true then
        if data.text:match('~b~PRESS: ~w~ALT') or data.text:match('~r~Press~w~ ALT') then
            if isKeyDown(0x02) then -- 
                goKeyPressed(18) -- 
            end
        end
    end
    if bool.autoH[0] == true then
        if data.text:match('~b~PRESS: ~w~H') then
            if terrcheck() then
                if not isKeyDown(0x20) then -- 
                    setVirtualKeyDown(87,false)
                    goKeyPressed(72) -- H 
                end
            end
        end
    end 
end
function imgui.stBut(text,bool,size)
    imgui.PushStyleColor(imgui.Col.Button, imgui.ImVec4(bool and 0.2 or 0.98,bool and 0.8 or 0.26,bool and 0.2 or 0.26, 0.55))
    imgui.PushStyleColor(imgui.Col.ButtonHovered, imgui.ImVec4(bool and 0.2 or 0.98,bool and 0.8 or 0.26,bool and 0.2 or 0.26, 0.55))
    imgui.PushStyleColor(imgui.Col.ButtonActive, imgui.ImVec4(bool and 0.2 or 0.98,bool and 0.8 or 0.26,bool and 0.2 or 0.26, 0.55))
    local button = imgui.Button(text, size)
    imgui.PopStyleColor(3)
    return button
end
function sampev.onCreate3DText(id, color, position, distance, testLOS, attachedPlayerId, attachedVehicleId, text)
    local text = text:gsub('{......}','')
    --   
    local nameNeft, waterCost, AZnef, Dollnef = text:match(' (.+)\n.+\n.+\n\n%$(.+)  1     \n(.+) AZ%-Coins %+ %$(.+)  1    %-')
    if nameNeft and waterCost and AZnef and Dollnef then
        if tostring(Dollnef:gsub('%p','')) ~= tostring(ini.set.moneydft) then
            ini.set.moneydft = Dollnef:gsub('%p','')
            inicfg.save(ini, 'OilHelper.ini')
        end
        if bool.minifpsup[0] then
            local text = ' {FF634F}:{FFFFFF} '..nameNeft..'\n{FF634F}[{FFFFFF} {FF634F}]{FFFFFF}   1 {FF634F}:{FFFFFF} '..waterCost..'{FF634F}$\n[{FFFFFF} {FF634F}]{FFFFFF}   1 {FF634F}:{FFFFFF} '..AZnef..' {FF634F}AZ-Coins{FFFFFF}  '..sumFormat(Dollnef)..'{FF634F}$'
            return {id, color, position, distance, testLOS, attachedPlayerId, attachedVehicleId, text}
        end
    end
    --  
    local pWaterCost, pAZnef, pDollnef = text:match(' .+%$(.+)  1     \n(.+) AZ%-Coins %+ %$(.+)  1    %-')
    if pWaterCost and pAZnef and pDollnef then
        if tostring(pDollnef:gsub('%p','')) ~= tostring(ini.set.moneydft) then
            ini.set.moneydft = pDollnef:gsub('%p','')
            inicfg.save(ini, 'OilHelper.ini')
        end
        if bool.minifpsup[0] then
            local text = ' \n{FF634F}[{FFFFFF} {FF634F}]{FFFFFF}   1 {FF634F}:{FFFFFF} '..pWaterCost..'{FF634F}$\n[{FFFFFF} {FF634F}]{FFFFFF}   1 {FF634F}:{FFFFFF} '..pAZnef..' {FF634F}AZ-Coins{FFFFFF}  '..sumFormat(pDollnef)..'{FF634F}$'
            return {id, color, position, distance, testLOS, attachedPlayerId, attachedVehicleId, text}
        end
    end

    --  
    local number, oil, barrels = text:match(" (%d+)\n %: (%d+) / %d+\n %: (%d+) / %d+")
    if number and oil and barrels then
        local costAZ = text:match('  500  %(%)%: (.+) AZ%-Coins')
        if costAZ and tostring(costAZ) ~= tostring(ini.set.azbarcost) then
            ini.set.azbarcost = costAZ
            inicfg.save(ini, 'OilHelper.ini')
        end
        if bool.minifpsup[0] then
            if tonumber(oil) >= 450 and tonumber(oil) < 500 then oil = '{F4A900} '..oil..'\n{FFFFFF}    '
            elseif tonumber(oil) >= 500 then oil = '{57A639} '..oil..'{FF634F} ({FFFFFF}'..math.floor(oil/500)..' '..(math.floor(oil/500)==1 and '' or math.floor(oil/500)<5 and '' or math.floor(oil/500)>=5 and '')..'{FF634F})'
            elseif tonumber(oil) < 450 then oil = '{FFFFFF} '..oil..'\n    ' end
            local text = '{FFFFFF} {FF634F}{FFFFFF}'..number..'\n{FFFFFF}{FF634F}: '..oil..'\n{FFFFFF}{FF634F}:{FFFFFF} '..barrels..'\n{FFFFFF} 1 {FF634F}:{FFFFFF} '..ini.set.azbarcost..' {FF634F}AZ-Coins'
            return {id, color, position, distance, testLOS, attachedPlayerId, attachedVehicleId, text}
        end
    end
    --  
    local allLitres, costBarrel = text:match(' %: (.+) \n\n  100%.0  %(%)%: %$(.+)')
    if allLitres and costBarrel then
        if tostring(costBarrel:gsub('%p','')) ~= tostring(ini.set.barellcost) then
            ini.set.barellcost = costBarrel:gsub('%p','')
            inicfg.save(ini, 'OilHelper.ini')
        end
        if bool.autoH[0] then
            textCoords.x = position.x
            textCoords.y = position.y
            textCoords.z = position.z
        end
        if bool.minifpsup[0] then
            local text = '{FFFFFF}  {FF634F}:{FFFFFF} '..allLitres..'\n  1 {FF634F}:{FFFFFF} '..costBarrel..' {FF634F}$'
            return {id, color, position, distance, testLOS, attachedPlayerId, attachedVehicleId, text}
        end
    end
    --   
    if bool.minifpsup[0] then
        if text:gsub('{......}',''):find(' %: ') then
            return false
        end
        local firstOnwer = text:match('  \n: (.+)')
        if firstOnwer then
            return {id, color, position, distance, testLOS, attachedPlayerId, attachedVehicleId, text}
        end
        local sLiter, sOwner = text:match(' \n%: (.+) \n%: (.+)\n\n')
        if sLiter and sOwner then
            local text = ': '..sOwner..' ('..sLiter..' .)'
            return {id, color, position, distance, testLOS, attachedPlayerId, attachedVehicleId, text}
        end
        local tLiter, tOwner = text:match('(.+) \n%: (.+)\n')
        if tLiter and tOwner then
            local text = ': '..tOwner..' ('..tLiter..' .)'
            return {id, color, position, distance, testLOS, attachedPlayerId, attachedVehicleId, text}
        end

    end
end
function obnul()
    ini.set.allaz = 0
    ini.set.allmon = 0
    ini.set.zaraztoday = 0
    ini.set.zartoday = 0
    ini.set.zarsecurity = 0
    zaraz, zarmon = 0,0
    inicfg.save(ini, 'OilHelper.ini')
end
-- OTHER -- 
function imgui.ColoredButton(text,hex,trans,size)
    local r,g,b = tonumber("0x"..hex:sub(1,2)), tonumber("0x"..hex:sub(3,4)), tonumber("0x"..hex:sub(5,6))
    if tonumber(trans) ~= nil and tonumber(trans) < 101 and tonumber(trans) > 0 then a = trans else a = 60 end
    imgui.PushStyleColor(imgui.Col.Button, imgui.ImVec4(r/255, g/255, b/255, a/100))
    imgui.PushStyleColor(imgui.Col.ButtonHovered, imgui.ImVec4(r/255, g/255, b/255, a/100))
    imgui.PushStyleColor(imgui.Col.ButtonActive, imgui.ImVec4(r/255, g/255, b/255, a/100))
    local button = imgui.Button(text, size)
    imgui.PopStyleColor(3)
    return button
end
function goKeyPressed(keyID)
    lua_thread.create(function()
        setVirtualKeyDown(keyID,true)
        wait(100)
        setVirtualKeyDown(keyID,false)
    end)
end
function imgui.CenterText(text)
    local width = imgui.GetWindowWidth()
    local calc = imgui.CalcTextSize(text)
    imgui.SetCursorPosX( width / 2 - calc.x / 2 )
    imgui.Text(text)
end
imgui.OnInitialize(function()
    imgui.GetIO().IniFilename = nil
    local config = imgui.ImFontConfig()
    config.MergeMode = true
    config.PixelSnapH = true
    iconRanges = imgui.new.ImWchar[3](faicons.min_range, faicons.max_range, 0)
    imgui.GetIO().Fonts:AddFontFromMemoryCompressedBase85TTF(faicons.get_font_data_base85('solid'), 14, config, iconRanges)
    theme()
end)
function theme()
    imgui.SwitchContext()
    local ImVec4 = imgui.ImVec4
    imgui.GetStyle().WindowPadding = imgui.ImVec2(5, 5)
    imgui.GetStyle().FramePadding = imgui.ImVec2(5, 5)
    imgui.GetStyle().ItemSpacing = imgui.ImVec2(5, 5)
    imgui.GetStyle().ItemInnerSpacing = imgui.ImVec2(2, 2)
    imgui.GetStyle().TouchExtraPadding = imgui.ImVec2(0, 0)
    imgui.GetStyle().IndentSpacing = 0
    imgui.GetStyle().ScrollbarSize = 10
    imgui.GetStyle().GrabMinSize = 10
    imgui.GetStyle().WindowBorderSize = 1
    imgui.GetStyle().ChildBorderSize = 1
    imgui.GetStyle().PopupBorderSize = 1
    imgui.GetStyle().FrameBorderSize = 1
    imgui.GetStyle().TabBorderSize = 1
    imgui.GetStyle().WindowRounding = 8
    imgui.GetStyle().ChildRounding = 8
    imgui.GetStyle().FrameRounding = 8
    imgui.GetStyle().PopupRounding = 8
    imgui.GetStyle().ScrollbarRounding = 8
    imgui.GetStyle().GrabRounding = 8
    imgui.GetStyle().TabRounding = 8
    imgui.GetStyle().Colors[imgui.Col.Text]                   = ImVec4(1.00, 1.00, 1.00, 1.00)
    imgui.GetStyle().Colors[imgui.Col.TextDisabled]           = ImVec4(0.50, 0.50, 0.50, 1.00)
    imgui.GetStyle().Colors[imgui.Col.WindowBg]               = ImVec4(0.06, 0.06, 0.06, 0.45)
    imgui.GetStyle().Colors[imgui.Col.ChildBg]                = ImVec4(0.00, 0.00, 0.00, 0.70)
    imgui.GetStyle().Colors[imgui.Col.PopupBg]                = ImVec4(0.08, 0.08, 0.08, 0.94)
    imgui.GetStyle().Colors[imgui.Col.Border]                 = ImVec4(0.43, 0.43, 0.50, 0.00)
    imgui.GetStyle().Colors[imgui.Col.BorderShadow]           = ImVec4(0.00, 0.00, 0.00, 0.00)
    imgui.GetStyle().Colors[imgui.Col.FrameBg]                = ImVec4(0.48, 0.16, 0.16, 0.54)
    imgui.GetStyle().Colors[imgui.Col.FrameBgHovered]         = ImVec4(0.98, 0.26, 0.26, 0.40)
    imgui.GetStyle().Colors[imgui.Col.FrameBgActive]          = ImVec4(0.98, 0.26, 0.26, 0.67)
    imgui.GetStyle().Colors[imgui.Col.TitleBg]                = ImVec4(0.04, 0.04, 0.04, 1.00)
    imgui.GetStyle().Colors[imgui.Col.TitleBgActive]          = ImVec4(0.48, 0.16, 0.16, 1.00)
    imgui.GetStyle().Colors[imgui.Col.TitleBgCollapsed]       = ImVec4(0.00, 0.00, 0.00, 0.51)
    imgui.GetStyle().Colors[imgui.Col.MenuBarBg]              = ImVec4(0.14, 0.14, 0.14, 1.00)
    imgui.GetStyle().Colors[imgui.Col.ScrollbarBg]            = ImVec4(0.02, 0.02, 0.02, 0.53)
    imgui.GetStyle().Colors[imgui.Col.ScrollbarGrab]          = ImVec4(0.31, 0.31, 0.31, 1.00)
    imgui.GetStyle().Colors[imgui.Col.ScrollbarGrabHovered]   = ImVec4(0.41, 0.41, 0.41, 1.00)
    imgui.GetStyle().Colors[imgui.Col.ScrollbarGrabActive]    = ImVec4(0.51, 0.51, 0.51, 1.00)
    imgui.GetStyle().Colors[imgui.Col.CheckMark]              = ImVec4(0.98, 0.26, 0.26, 1.00)
    imgui.GetStyle().Colors[imgui.Col.SliderGrab]             = ImVec4(0.88, 0.26, 0.24, 1.00)
    imgui.GetStyle().Colors[imgui.Col.SliderGrabActive]       = ImVec4(0.98, 0.26, 0.26, 1.00)
    imgui.GetStyle().Colors[imgui.Col.Button]                 = ImVec4(0.98, 0.26, 0.26, 0.40)
    imgui.GetStyle().Colors[imgui.Col.ButtonHovered]          = ImVec4(0.98, 0.26, 0.26, 1.00)
    imgui.GetStyle().Colors[imgui.Col.ButtonActive]           = ImVec4(0.98, 0.06, 0.06, 1.00)
    imgui.GetStyle().Colors[imgui.Col.Header]                 = ImVec4(0.98, 0.26, 0.26, 0.31)
    imgui.GetStyle().Colors[imgui.Col.HeaderHovered]          = ImVec4(0.98, 0.26, 0.26, 0.80)
    imgui.GetStyle().Colors[imgui.Col.HeaderActive]           = ImVec4(0.98, 0.26, 0.26, 1.00)
    imgui.GetStyle().Colors[imgui.Col.Separator]              = ImVec4(0.43, 0.43, 0.50, 0.50)
    imgui.GetStyle().Colors[imgui.Col.SeparatorHovered]       = ImVec4(0.75, 0.10, 0.10, 0.78)
    imgui.GetStyle().Colors[imgui.Col.SeparatorActive]        = ImVec4(0.75, 0.10, 0.10, 1.00)
    imgui.GetStyle().Colors[imgui.Col.ResizeGrip]             = ImVec4(0.98, 0.26, 0.26, 0.25)
    imgui.GetStyle().Colors[imgui.Col.ResizeGripHovered]      = ImVec4(0.98, 0.26, 0.26, 0.67)
    imgui.GetStyle().Colors[imgui.Col.ResizeGripActive]       = ImVec4(0.98, 0.26, 0.26, 0.95)
    imgui.GetStyle().Colors[imgui.Col.Tab]                    = ImVec4(0.98, 0.26, 0.26, 0.40)
    imgui.GetStyle().Colors[imgui.Col.TabHovered]             = ImVec4(0.98, 0.26, 0.26, 1.00)
    imgui.GetStyle().Colors[imgui.Col.TabActive]              = ImVec4(0.98, 0.06, 0.06, 1.00)
    imgui.GetStyle().Colors[imgui.Col.TabUnfocused]           = ImVec4(0.98, 0.26, 0.26, 1.00)
    imgui.GetStyle().Colors[imgui.Col.TabUnfocusedActive]     = ImVec4(0.98, 0.26, 0.26, 1.00)
    imgui.GetStyle().Colors[imgui.Col.PlotLines]              = ImVec4(0.61, 0.61, 0.61, 1.00)
    imgui.GetStyle().Colors[imgui.Col.PlotLinesHovered]       = ImVec4(1.00, 0.43, 0.35, 1.00)
    imgui.GetStyle().Colors[imgui.Col.PlotHistogram]          = ImVec4(0.90, 0.70, 0.00, 1.00)
    imgui.GetStyle().Colors[imgui.Col.PlotHistogramHovered]   = ImVec4(1.00, 0.60, 0.00, 1.00)
    imgui.GetStyle().Colors[imgui.Col.TextSelectedBg]         = ImVec4(0.98, 0.26, 0.26, 0.35)
end
function imgui.TextColoredRGB(text)
    local style = imgui.GetStyle()
    local colors = style.Colors
    local ImVec4 = imgui.ImVec4

    local explode_argb = function(argb)
        local a = bit.band(bit.rshift(argb, 24), 0xFF)
        local r = bit.band(bit.rshift(argb, 16), 0xFF)
        local g = bit.band(bit.rshift(argb, 8), 0xFF)
        local b = bit.band(argb, 0xFF)
        return a, r, g, b
    end

    local getcolor = function(color)
        if color:sub(1, 6):upper() == 'SSSSSS' then
            local r, g, b = colors[1].x, colors[1].y, colors[1].z
            local a = tonumber(color:sub(7, 8), 16) or colors[1].w * 255
            return ImVec4(r, g, b, a / 255)
        end
        local color = type(color) == 'string' and tonumber(color, 16) or color
        if type(color) ~= 'number' then return end
        local r, g, b, a = explode_argb(color)
        return imgui.ImVec4(r/255, g/255, b/255, a/255)
    end

    local render_text = function(text_)
        for w in text_:gmatch('[^\r\n]+') do
            local text, colors_, m = {}, {}, 1
            w = w:gsub('{(......)}', '{%1FF}')
            while w:find('{........}') do
                local n, k = w:find('{........}')
                local color = getcolor(w:sub(n + 1, k - 1))
                if color then
                    text[#text], text[#text + 1] = w:sub(m, n - 1), w:sub(k + 1, #w)
                    colors_[#colors_ + 1] = color
                    m = n
                end
                w = w:sub(1, n - 1) .. w:sub(k + 1, #w)
            end
            if text[0] then
                for i = 0, #text do
                    imgui.TextColored(colors_[i] or colors[1], text[i])
                    imgui.SameLine(nil, 0)
                end
                imgui.NewLine()
            else imgui.Text(w) end
        end
    end

    render_text(text)
end
function sumFormat(a)
    local ost = tostring(a):match('.+%.(.+)')
    local b, e = ('%d'):format(a):gsub('^%-', '')
    local c = b:reverse():gsub('%d%d%d', '%1,')
    local d = c:reverse():gsub('^%,', '')
    return string.format('%s%s%s',(e == 1 and '-' or ''),d,ost and '.'..ost or '')
end